/* Written by Tom Almy, 1:105/290, and placed in public domain */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
int zone=1, region=17, net=105;
void main(int argc, char **argv) {
	char linebuf[256];
	char tempbuf[32];
	int buflen;
	char *result;
	if (argc == 4) {
		sscanf(argv[1],"%d",&zone);
		sscanf(argv[2],"%d",&region);
		sscanf(argv[3],"%d",&net);
	}
	if (argc == 3) {
		sscanf(argv[1],"%d",&zone);
		sscanf(argv[2],"%d",&net);
		region=0;
	}
	else if (argc == 2) {
		sscanf(argv[1],"%d",&net);
	}

	if (region)	printf("; Nodelist for %d:%d, region %d\n", zone, net, region);
	else 	printf("; Nodelist for %d:%d\n", zone, net);
    puts("; NOTICE -- THIS IS NOT A BBS LIST! Many listed systems are NOT");
	puts("; BBS's. Do NOT call systems with \"MO\" (mail only) in their");
	puts("; description, or systems which do not have a \"CM\" in their");
	puts("; description. Better yet, use a real BBS LIST such as PDXBBS,");
	puts("; available at many BBSes in the Portland area.");
/* get the ZC */
	sprintf(tempbuf,"Zone,%d,", zone);
	buflen = strlen(tempbuf);
	while ((result = fgets(linebuf, 256, stdin)) != NULL) {
		if (strncmp(linebuf, tempbuf, buflen) == 0) {
			fputs(linebuf, stdout);
			break;
		}
	}
	if (result == NULL) exit(1);

/* get the zonegates */
	if (zone==1) {
		do  {
			if (fgets(linebuf, 256, stdin) == NULL) exit(1);
			fputs(linebuf, stdout);
		} while (strncmp(linebuf, ",6,", 3) != 0);
	}
/* get the RC */
	if (region != 0) {
		sprintf(tempbuf,"Region,%d,", region);
		buflen = strlen(tempbuf);
		while ((result = fgets(linebuf, 256, stdin)) != NULL) {
			if (strncmp(linebuf, tempbuf, buflen) == 0) {
				fputs(linebuf, stdout);
				break;
			}
		}
		if (result == NULL) exit(1);

/* get the region independents */
		if (fgets(linebuf, 256, stdin) == NULL) exit(1);
		while (strncmp(linebuf, "Host,", 5) != 0) {
			fputs(linebuf, stdout);
			if (fgets(linebuf, 256, stdin) == NULL) exit(1);
		}
	}

/* get net 105 */
	sprintf(tempbuf,"Host,%d,", net);
	buflen = strlen(tempbuf);
	while (strncmp(linebuf, tempbuf, buflen) != 0) {
		if (fgets(linebuf, 256, stdin) == NULL) exit(1);
	}
	fputs(linebuf, stdout);
	if (fgets(linebuf, 256, stdin) == NULL) exit(1);
	while (strncmp(linebuf, "Host,", 5) != 0) {
		fputs(linebuf, stdout);
		if (fgets(linebuf, 256, stdin) == NULL) exit(1);
	}

	exit(0);	/* we are done! */
}
